#ifndef OPENTISSUE_DYNAMICS_SPH_SOLVERS_SPH_SOLVERS_H 
#define OPENTISSUE_DYNAMICS_SPH_SOLVERS_SPH_SOLVERS_H
//
// OpenTissue Template Library
// - A generic toolbox for physics-based modeling and simulation.
// Copyright (C) 2008 Department of Computer Science, University of Copenhagen.
//
// OTTL is licensed under zlib: http://opensource.org/licenses/zlib-license.php
//
#include <OpenTissue/configuration.h>

/**
 * Main SPH/Solvers include file.
 * Recursively includes required headers.
 */
#include <OpenTissue/dynamics/sph/solvers/sph_color.h>
#include <OpenTissue/dynamics/sph/solvers/sph_buoyancy.h>
#include <OpenTissue/dynamics/sph/solvers/sph_density.h>
#include <OpenTissue/dynamics/sph/solvers/sph_gravity.h>
#include <OpenTissue/dynamics/sph/solvers/sph_normal.h>
#include <OpenTissue/dynamics/sph/solvers/sph_pressure.h>
#include <OpenTissue/dynamics/sph/solvers/sph_surface.h>
#include <OpenTissue/dynamics/sph/solvers/sph_viscosity.h>

// OPENTISSUE_DYNAMICS_SPH_SOLVERS_SPH_SOLVERS_H
#endif 
