#--------------------------------------------------------------------
#
# This marcro was taken from
#
#   http://www.cmake.org/Wiki/CMakeMacroGenerateProject
#
# Typical usage
#
#   GenerateProject ( src/MyLib "${MyLibSources}" )
#   ADD_LIBRARY (MyLib SHARED ${MyLibSources} )
#

# create hierarchical source groups
MACRO ( GenerateProject ProjectDir ProjectSources )
  
  SET ( DirSources "${ProjectSources}" )
  FOREACH ( Source ${DirSources} )

    STRING ( REGEX REPLACE "${ProjectDir}" "" RelativePath "${Source}" )
    STRING ( REGEX REPLACE "[\\\\/][^\\\\/]*$" "" RelativePath "${RelativePath}" )
    STRING ( REGEX REPLACE "^[\\\\/]" "" RelativePath "${RelativePath}" )
    STRING ( REGEX REPLACE "/" "\\\\\\\\" RelativePath "${RelativePath}" )
    SOURCE_GROUP ( "${RelativePath}" FILES ${Source} )
  ENDFOREACH ( Source )
ENDMACRO ( GenerateProject)