// Copyright (C) 2011 Soren Hauberg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, see <http://www.gnu.org/licenses/>.
 
#include "bone_appearance.h"
#include "auxil.h"

// Constructor
bone_appearance::bone_appearance ()
{
  set_size (1, 0);
}

// Accessor
void bone_appearance::set_size (const double _width, const double _length)
{
  width = _width;
  length2 = square (_length);
}

double bone_appearance::get_width () const
{
  return width;
}

double bone_appearance::get_length () const
{
  return sqrt (length2);
}

double bone_appearance::get_length2 () const
{
  return length2;
}

