// Copyright (C) 2011 Soren Hauberg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, see <http://www.gnu.org/licenses/>.
 
#ifndef GLAUXIL_H
#define GLAUXIL_H

#ifdef __APPLE__
  #include <glut.h>
#else
  #include <GL/glut.h>
#endif
#include "math_types.h"

/**
 Draw parts of a cylinder, i.e. only draw part of the rotation.
 
 @param [in] radius
 Radius of the cylinder.
 
 @param [in] height
 Height of the cylinder.
 
 @param [in] theta_start
 The beginning of the rotational interval.
 
 @param [in] theta_stop
 The end of the rotational interval.
 */
void partial_cylinder (float radius, float height, float theta_start, float theta_stop);

/**
 Draws a camera.
 
 @param [in] cam
 Center of the camera.
 */
void draw_camera (const vector3 &cam);

#endif // GLAUXIL_H
