// Copyright (C) 2011 Soren Hauberg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, see <http://www.gnu.org/licenses/>.
 
#include "gui.h"
#include "macros.h"

#define EXPAND(STATE_NAME, STATE_TYPE, OBS_NAME, OBS_TYPE)                          \
        if (st == STATE_NAME && ot == OBS_NAME)                                     \
          {                                                                         \
            instance.reset (new TrackerGUI< TRACKER (STATE_TYPE, OBS_TYPE) >        \
                           (#STATE_TYPE " " #OBS_TYPE " Tracker", opts, playback)); \
          }

OpenTissue::glut::instance_pointer init_glut_application (int argc, char *argv [])
{
  // Disable localisation as that can screw with punctuation in numerical IO
  setenv ("LANG", "", 1);

  // Command line options
  const std::string options_filename = (argc > 1) ? argv [1] : "";
  const options opts (options_filename);
  const bool playback = (argc > 2 && argv [2] == std::string ("--playback"));

  // Create GUI
  const tracker_state_type st = opts.state_type ();
  const tracker_observation_type ot = opts.observation_type ();

  OpenTissue::glut::instance_pointer instance;
  
  EXPAND_ALL_TRACKERS
        
  return instance;
}


