// Copyright (C) 2011 Soren Hauberg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, see <http://www.gnu.org/licenses/>.
 
#include "headless_tracker.h"
#include "macros.h"

#define EXPAND(STATE_NAME, STATE_TYPE, OBS_NAME, OBS_TYPE)                    \
        if (st == STATE_NAME && ot == OBS_NAME)                               \
          {                                                                   \
            HeadlessTracker< TRACKER (STATE_TYPE, OBS_TYPE) > tracker (opts); \
          }

/**
 A simple program that runs the tracker without any visualisation. This is suitable
 for running the code an machine without displays, e.g. clusters.
 */
int main (int argc, char *argv [])
{
  // Disable localisation as that screws with punctuation in numerical IO
  setenv ("LANG", "", 1);

  if (argc < 2)
    std::cerr << argv [0] << ": not enough input arguments" << std::endl;
  else
    {
      const options opts (argv [1]);
 
      // Create tracker
      const tracker_state_type st = opts.state_type ();
      const tracker_observation_type ot = opts.observation_type ();

      EXPAND_ALL_TRACKERS    
    }
         
  return 0;
}

