// Copyright (C) 2011 Soren Hauberg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, see <http://www.gnu.org/licenses/>.
 
#ifndef HEADLESS_TRACKER_H
#define HEADLESS_TRACKER_H

#include "pf_skeleton_tracker.h"
#include "auxil.h"
#include "options.h"
#include <boost/progress.hpp>

/**
 A simple class for tracking applications without any visualisation.
 */
template <class tracker_type>
class HeadlessTracker
{
public:
  HeadlessTracker (const options &opts)
    {
      calibration calib (opts);
      tracker_type track (opts, calib);
      
      boost::progress_timer benchmark;

      // For each frame
      while (track.refresh ())
        track.save_states ();
    }  
};

#endif // HEADLESS_TRACKER_H
