// Copyright (C) 2011 Soren Hauberg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, see <http://www.gnu.org/licenses/>.
 
#ifndef INDEX_H
#define INDEX_H

#define GRAY(IMAGE, X, Y) \
    ((uchar*)((IMAGE)->imageData  + (IMAGE)->widthStep*(Y)))[X]
#define RED(IMAGE, X, Y) \
  ((uchar*)((IMAGE)->imageData + (IMAGE)->widthStep*(Y)))[(X)*3+2]
#define GREEN(IMAGE, X, Y) \
  ((uchar*)((IMAGE)->imageData + (IMAGE)->widthStep*(Y)))[(X)*3+1]
#define BLUE(IMAGE, X, Y) \
  ((uchar*)((IMAGE)->imageData + (IMAGE)->widthStep*(Y)))[(X)*3]
#define HUE(IMAGE, X, Y) \
  ((uchar*)((IMAGE)->imageData + (IMAGE)->widthStep*(Y)))[(X)*3]
#define SAT(IMAGE, X, Y) \
  ((uchar*)((IMAGE)->imageData + (IMAGE)->widthStep*(Y)))[(X)*3+1]
#define VAL(IMAGE, X, Y) \
  ((uchar*)((IMAGE)->imageData + (IMAGE)->widthStep*(Y)))[(X)*3+2]

#define GRAY16(IMAGE, X, Y) \
    ((unsigned short*)((IMAGE)->imageData  + (IMAGE)->widthStep*(Y)))[X]
#define GRAY32(IMAGE, X, Y) \
    ((int*)((IMAGE)->imageData  + (IMAGE)->widthStep*(Y)))[X]

#define GRAY_T(TYPE, IMAGE, X, Y) \
    ((TYPE*)((IMAGE)->imageData  + (IMAGE)->widthStep*(Y)))[X]
#define RED_T(TYPE, IMAGE, X, Y) \
  ((TYPE*)((IMAGE)->imageData + (IMAGE)->widthStep*(Y)))[(X)*3+2]
#define GREEN_T(TYPE, IMAGE, X, Y) \
  ((TYPE*)((IMAGE)->imageData + (IMAGE)->widthStep*(Y)))[(X)*3+1]
#define BLUE_T(TYPE, IMAGE, X, Y) \
  ((TYPE*)((IMAGE)->imageData + (IMAGE)->widthStep*(Y)))[(X)*3]

#define GRAY32F(IMAGE, X, Y) \
    ((float*)((IMAGE)->imageData  + (IMAGE)->widthStep*(Y)))[X]

#endif
