// Copyright (C) 2011 Soren Hauberg
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, see <http://www.gnu.org/licenses/>.
 
#ifndef MACROS_H
#define MACROS_H

// Macros for expanding the various number of supported trackers
// You need to define EXPAND before calling these macros
#define EXPAND_PLAIN_OBS(STATE_NAME, STATE_TYPE)                               \
        EXPAND(STATE_NAME, STATE_TYPE, POINT_CLOUD, point_cloud)               \
        else                                                                   \
        EXPAND(STATE_NAME, STATE_TYPE, POINT_CLOUD_AND_STICK, point_cloud_and_stick) \
        else                                                                   \
        EXPAND(STATE_NAME, STATE_TYPE, KINECT_CLOUD, kinect_cloud)             \
        else                                                                   \
        EXPAND(STATE_NAME, STATE_TYPE, TRICLOPS_CLOUD, triclops_cloud)

#define EXPAND_STICK_OBS(STATE_NAME, STATE_TYPE)                               \
        EXPAND(STATE_NAME, STATE_TYPE, POINT_CLOUD_AND_STICK, point_cloud_and_stick)

#define EXPAND_ALL_TRACKERS                                                    \
  EXPAND_PLAIN_OBS (ANGLE_STATE, angle_state)                                  \
  else                                                                         \
  EXPAND_PLAIN_OBS (PIK_STATE, pik_state)                                      \
  else                                                                         \
  EXPAND_PLAIN_OBS (PROJECTION_STATE, projection_state)                        \
  else                                                                         \
  EXPAND_PLAIN_OBS (TANGENT_STATE, tangent_state)                              \
  else                                                                         \
  EXPAND_PLAIN_OBS (BGSUB_STATE, bgsub_state)                                  \
  else                                                                         \
  EXPAND_PLAIN_OBS (ANGLE_BGSUB_STATE, angle_bgsub_state)                      \
  else                                                                         \
  EXPAND_PLAIN_OBS (HULL_STATE, hull_state)                                    \
  else                                                                         \
  EXPAND_PLAIN_OBS (BROWNIAN_STATE, brownian_state)                            \
  else                                                                         \
  EXPAND_STICK_OBS (PIK_STATE, pik_state)                                      \
  else                                                                         \
  EXPAND_STICK_OBS (KBK_STICK_STATE, KBK_stick_state)                          \
  else                                                                         \
  EXPAND_STICK_OBS (STICK_STATE, stick_state)                                  \
  else                                                                         \
  EXPAND_STICK_OBS (STICK2D_STATE, stick2d_state)                              \
  else                                                                         \
  EXPAND_STICK_OBS (PIK_STICK_STATE, pik_stick_state)                          \
  else                                                                         \
  EXPAND_STICK_OBS (BROWNIAN_STICK_STATE, brownian_stick_state)                \
  else                                                                         \
    {                                                                          \
      std::cerr << "Unsupported combination of state and observation type"     \
                << std::endl;                                                  \
    }

#endif // MACROS_H

